"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fastify_plugin_1 = __importDefault(require("fastify-plugin"));
const routes_1 = __importDefault(require("@fastify/routes"));
const compile_1 = require("./compile");
const prettify_1 = require("./prettify");
const constants_1 = require("./constants");
const save_1 = require("./save");
__exportStar(require("./types"), exports);
const plugin = async (fastify, options = { enabled: false, outputs: {} }, done) => {
    if (!options.enabled) {
        done();
        return;
    }
    fastify.register(routes_1.default);
    fastify.addHook('onReady', async () => {
        var _a, _b;
        const app = fastify;
        const definitions = app.getSchemas();
        const outputs = Object.keys(options.outputs);
        const baseComment = ((_a = options.compilerOptions) === null || _a === void 0 ? void 0 : _a.bannerComment) || constants_1.bannerComment;
        const [{ text, schema }, prettier] = await Promise.all([
            (0, compile_1.compile)(app.routes, definitions, (_b = options.ignoreHead) !== null && _b !== void 0 ? _b : false, options.compilerOptions),
            (0, prettify_1.prettify)(options.compilerOptions),
        ]);
        if (options.onSchemaReady) {
            await options.onSchemaReady(schema);
        }
        await Promise.all(outputs.map(async (output) => {
            const item = options.outputs[output];
            const isServer = item.target === 'serverTypes';
            const banner = baseComment + (isServer ? constants_1.bannerImports : '');
            const formatted = await prettier(banner + text);
            await (0, save_1.save)(formatted, output);
        }));
    });
    done();
};
exports.default = (0, fastify_plugin_1.default)(plugin, {
    fastify: '4.x',
    name: 'fastify-extract-definitions',
});
